

@echo off
cd /d %~dp0


net session >nul 2>&1
if %errorlevel% equ 0 (
  call:log Administrator PRIVILEGES Detected!
) else (
  call:log ########## ERROR: ADMINISTRATOR PRIVILEGES REQUIRED ##########
  call:log This script must be run as administrator to work properly!
  call:log Right click on the shortcut and select "Run As Administrator".
  call:log ##############################################################
  pause
  exit /b 1
)

set PROCESSOR_ARCHITECTURE
if /i "%PROCESSOR_ARCHITECTURE%"=="x86" (set srcfile=wincmder-shellex-x86.dll) else (set srcfile=wincmder-shellex-x64.dll)
if not exist %srcfile% goto:eof

set dstdir_old=%ProgramFiles%\Wincmder
set dstdir=%ProgramFiles%\Wincmder\Shellex
set dllpath="%dstdir%\%srcfile%"
set dllpath


reg query "HKCR\CLSID\{FFDFBA89-F169-4a23-89E6-EE4A27B73C41}" >nul 2>&1
if errorlevel 1 goto:not_found


call:log cleanup registry entries
regsvr32 /s /u %srcfile%


ver | find " 5." >nul
if %errorlevel% equ 0 (
  call:log need restart explorer.exe unconditionally
  taskkill /f /im explorer.exe
  ping -n 3 localhost >nul 2>&1
  start explorer.exe
)


if not exist %dllpath% exit /b 0


2>nul (
  >>%dllpath% (call )
) && (goto:when_not_locked) || (goto:when_locked)
exit /b 404



:not_found
call:log do not need uninstall
exit /b 0



:when_locked
call:log %dllpath% is LOCKED, try restart explorer.exe
taskkill /f /im explorer.exe
ping -n 3 localhost >nul 2>&1
start explorer.exe
2>nul (
  >>%dllpath% (call )
) && (goto:when_not_locked) || (goto:still_locked)
exit /b 404


:still_locked
call:log %dllpath% is still LOCKED, you may unlock it by yourself, or just logout Windows to unlock it
pause
exit /b 1


:when_not_locked
call:log %dllpath% is NOT locked, delete it
del /q /s %dllpath%
call:log delete "%dstdir%"
rd /q /s "%dstdir%"
rd /q /s "%dstdir_old%"
exit /b 0


:log
echo %~n0: %*
echo %~n0: %*>>INSTALL.log
exit /b


